//
//  Character.h
//  Four Ee
//
//  Created by Thomas Castiglione on 7/06/08.
//  Copyright 2008 Bananasoft. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "CharacterClass.h"
#import "CharacterRace.h"

//
//	4e character definition
//
@interface Character : NSObject {
	NSXMLDocument *sheet;
	
	// AVAILABLE races and classes
	NSArray* races;
	NSArray* classes;
	
	//Properties of the SELECTED race and class
	CharacterRace* raceBonuses;	
	CharacterClass* classBonuses;
}

//
// Static methods
//

+ (int)modifierForValue:(int)stat;
+ (NSArray*)statNames;

//
// Constructor
//

- (id)initWithData:(NSData*)sheetXML;
- (NSData*)data;

//
// Generative mutators
//

- (int)fdsl;
- (void)reroll;


//
// Calculating accessors
//

- (int)strMod;
- (int)conMod;
- (int)dexMod;
- (int)intMod;
- (int)wisMod;
- (int)chaMod;

- (int)pointCost;

- (int)halfLevel;

- (int)AC;
- (int)fort;
- (int)ref;
- (int)will;
- (int)ACAbil;
- (int)fortAbil;
- (int)refAbil;
- (int)willAbil;

- (int)hitPoints;
- (int)healingSurges;
- (int)initiative;

//
// Automatic properties
//

@property(retain) NSArray* races;
@property(retain) NSArray* classes;

@property(retain) CharacterRace* raceBonuses;
@property(retain) CharacterClass* classBonuses;

//
// Properties for XML
//

@property(copy) NSString* name;

@property(copy) NSString* race;
@property(copy) NSString* cclass;

@property int level;
@property int experience;

@property int strength;
@property int constitution;
@property int dexterity;
@property int intelligence;
@property int wisdom;
@property int charisma;

@end
