//
//  CharacterRace.m
//  Four Ee
//
//  Created by Thomas Castiglione on 7/06/08.
//  Copyright 2008 __MyCompanyName__. All rights reserved.
//

#import "CharacterRace.h"


@implementation CharacterRace

// XXX hardcoded, make this load from data files
+ (NSArray*)loadRaces {
	return [NSArray arrayWithObjects:[[CharacterRace alloc] initWithName:@"Dragonborn" str:2 con:0 dex:0 intel:0 wis:0 cha:2 speed:6],
	 [[CharacterRace alloc] initWithName:@"Dwarf" str:0 con:2 dex:0 intel:0 wis:2 cha:0 speed:5],
	 [[CharacterRace alloc] initWithName:@"Eladrin" str:0 con:0 dex:2 intel:2 wis:0 cha:0 speed:6],
	 [[CharacterRace alloc] initWithName:@"Elf" str:0 con:0 dex:2 intel:0 wis:2 cha:0 speed:7],
	 [[CharacterRace alloc] initWithName:@"Half-Elf" str:0 con:2 dex:0 intel:0 wis:0 cha:2 speed:6],
	 [[CharacterRace alloc] initWithName:@"Halfling" str:0 con:0 dex:2 intel:0 wis:0 cha:2 speed:6],
	 [[CharacterRace alloc] initWithName:@"Tiefling" str:0 con:0 dex:0 intel:2 wis:0 cha:2 speed:6],
	 nil];
}
	
- (id)initWithName:(NSString*)n str:(int)s con:(int)c dex:(int)d intel:(int)i wis:(int)w cha:(int)ch speed:(int)spd {
	self = [super init];
	
	if (self) {
		[self setName: n];
		
		strength = s;
		constitution = c;
		dexterity = d;
		intelligence = i;
		wisdom = w;
		charisma = ch;
		
		speed = spd;
	}
	
	return self;
}

//
// properties
//

@synthesize name;

@synthesize strength;
@synthesize constitution;
@synthesize dexterity;
@synthesize intelligence;
@synthesize wisdom;
@synthesize charisma;

@synthesize speed;

@synthesize skillBonuses;

//save/load

- (void)encodeWithCoder:(NSCoder*)coder {
	[coder encodeObject:name	forKey:@"CRname"];
	
	[coder encodeInt:strength		forKey:@"CRstr"];
	[coder encodeInt:constitution	forKey:@"CRcon"];
	[coder encodeInt:dexterity		forKey:@"CRdex"];
	[coder encodeInt:intelligence	forKey:@"CRint"];
	[coder encodeInt:wisdom			forKey:@"CRwis"];
	[coder encodeInt:charisma		forKey:@"CRcha"];
	
	[coder encodeInt:speed			forKey:@"CRspeed"];
}

- (id)initWithCoder:(NSCoder*)coder {
	[self initWithName: [coder decodeObjectForKey:	@"CRname"]
				   str: [coder decodeIntForKey:		@"CRstr"]
				   con: [coder decodeIntForKey:		@"CRcon"]
				   dex: [coder decodeIntForKey:		@"CRdex"]
				 intel: [coder decodeIntForKey:		@"CRintel"]
				   wis: [coder decodeIntForKey:		@"CRwis"]
				   cha: [coder decodeIntForKey:		@"CRcha"]
				 speed: [coder decodeIntForKey:		@"CRspeed"]];
	
	return self;
}

- (BOOL)isEqual:(id)anObject {
	if ([anObject isKindOfClass:NSClassFromString(@"NSString")]) {
		return ([name caseInsensitiveCompare:anObject] == NSOrderedSame);
	}
	
	return [super isEqual:anObject];
}

- (NSUInteger)hash {
	return [name hash];
}

@end
