//
//  MyDocument.m
//  Four Ee
//
//  Created by Thomas Castiglione on 2/06/08.
//  Copyright Bananasoft 2008 . All rights reserved.
//

#import "MyDocument.h"

@implementation MyDocument

- (NSString *)windowNibName
{
    return @"CharacterSheet";
}

@synthesize character;

- (id)init
{
    self = [super init];
    if (self) {
		NSString* resourceLoc = [[NSBundle mainBundle] resourcePath];
		NSLog(resourceLoc);
		NSData* initData = [NSData dataWithContentsOfFile:[resourceLoc stringByAppendingString:BLANK_SHEET]];
		
		chdir([resourceLoc UTF8String]);
        character = [[Character alloc] initWithData:initData];
    }
    return self;
}

- (NSData *)dataOfType:(NSString *)typeName error:(NSError **)outError {
	return [character data];
}

- (BOOL)readFromData:(NSData *)data ofType:(NSString *)typeName error:(NSError **)outError {
	character = [[Character alloc] initWithData:data];

	return YES;
}

- (IBAction)reroll:(id)sender {
	[character reroll];
}

- (void)windowControllerDidLoadNib:(NSWindowController *)windowController {
	[super windowControllerDidLoadNib:windowController];
	
	//Programmatic bindings
	[raceController setSelectionIndex:[[character races]
									   indexOfObject:[character race]]];
	[classController setSelectionIndex:[[character classes]
										indexOfObject:[character cclass]]];
	
	[character bind:@"race" toObject:raceController withKeyPath:@"selection.name" options:nil];
	[character bind:@"cclass" toObject:classController withKeyPath:@"selection.name" options:nil];
}

- (NSPrintOperation *)printOperationWithSettings:(NSDictionary*)printSettings error:(NSError**)outError{
	NSLog(@"attempting to print");
	
	*outError = [[NSError alloc] initWithDomain:@"Four Ee" code:0 userInfo:nil];
	
	return nil;
}

@end
